ChiliProject - Bug # 441: Creating a Journal does not update the journaled record's updated_at/on
attribute

Status: Closed Priority: Normal

Author: Eric Davis Category: Journals / History
Created: 2011-06-02 Assignee: Eric Davis
Updated: 2011-07-29 Due date:

Remote issue URL:

Affected version: unstable

Description: To reproduce:

# Create an issue (updated_on is set to A)
# Create a journal for the issue
# The issue's updated_on stays the same (updated on should have been A + some_time)

Associated revisions

2011-06-05 08:49 pm - Eric Davis

[#441] Journals should touch their journaled to update updated_on/at fields

History

2011-06-02 04:57 am - Eric Davis
- File 0001-441-Journals-should-touch-their-journaled-to-update-.patch added

- Status changed from Open to Needs more information

Having problems getting this to work. All it should be is to just add "touch" to a Journal (@belongs_to :journaled, :touch => true@) but I'm now having to

fix (brittle) tests in issues nested set, reload records in a bunch of tests, and now aaj isn't updating it's journal version (JournalObserverTest).

Could someone try this out and see if I'm missing something simple. I've already spent 4 hours on this...

2011-06-05 06:56 pm - Eric Davis

- Status changed from Needs more information to Ready for review

Found out that the JournalObserverTest wasn't creating the initial journals correctly sometimes which was causing the version problems. | ended up

fixing the test by removing the fixtures and adding in factories.

Final code in https://github.com/chiliproject/chiliproject/pull/72

2011-06-10 06:42 pm - Eric Davis

- Status changed from Ready for review to Closed

Merged into release-v2.0.0 in commit:ee9b129

2011-07-28 06:42 am - Felix Schéfer

Eric, we're having problems with StaleObjectErrors in migrations for journalized objects (similar to wiki pages), in tests, and | somehow remember other

people having those too, | can't find them here though.

Anyway, | was able to find a (probable) culprit, it's the @:touch => true@ part in source:/app/models/journal.rb#L27, which gets triggered again if there's

2020-10-25 1/2



stuff done on the journal after it's been saved, as is e.g. the case with the @update_attribute@ in source:/app/models/wiki_content.rb#L96. | understand

the need to touch the journalized object on journal creation, but it's not necessary on journal post-processing (I'd even say it's wrong).

Would you agree to moving the touch action to an @after_create@ callback instead of having it in an @after_save@/@after_destroy@ (see
"add_touch_callbacks":http://apidock.com/rails/v2.3.8/ActiveRecord/Associations/ClassMethods/add_touch_callbacks about that)?

2011-07-28 05:31 pm - Gregor Schmidt

- File 0001-441-Updating-issue-on-comments-with-less-undesired-s.patch added

Attach is the proposed change in git patch format. The tests run fine on MySQL.

2011-07-29 09:34 am - Felix Schafer
Discussion moved to #543.

Files
0001-441-Journals-should-touch-their-journaled-to-update-.patch 13.7 kB 2011-06-02 Eric Davis
0001-441-Updating-issue-on-comments-with-less-undesired-s.patch 1.1 kB 2011-07-28 Gregor Schmidt
